package associations;

import java.util.List;

/**
 * Other way to remove mutual dependency using an interface
 * Lookup in one direction 
 * @author hajo
 *
 */
public class RemoveMutualAssociations4 {

	public static void main(String[] args) {
		ICustomer c = new Customer();
		Order o = new Order(c);
		ICustomer whoToBill = o.getOwner();

		System.out.println(whoToBill);

	}

	public static class Order {
		// Dependency on interface
		ICustomer owner;
		public Order(ICustomer owner) {
			this.owner = owner;
		}
		public ICustomer getOwner() {
			return owner;
		}
	}
	
	public interface ICustomer {
		
	}

	public static class Customer implements ICustomer {
		// Dependency on Order
		private List<Order> orders;
	}

}
