package infohiding;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

/**
 * Don't tell its a List use an iterator
 * @author hajo
 *
 */
public class DontExposeStructure {

	public static class Game{
		// Players are immutable
		public final List<Player> players = new ArrayList<>();
		
		// Exposing implementation details (List)
		public List<Player> getPlayers(){
			return players;
		}
		// Is it a List or ...?
		public Collection<Player> betterGetPlayers(){
			return players;
		}
		// Read only!
		public Collection<Player> evenBetterGetPlayers(){
			return Collections.unmodifiableList(players);
		}
	}
	
	// -------- TYPES ------------
	
	public static class Player{
		// A dummy
	}
		
}
