package interfacesegregation;

/**
 * Separating out different interfaces to be used
 * by different parts (thereby achieving info hiding)
 * @author hajo
 *
 */
public class InterfaceSegregation {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		IVIPCustomer vip = new Customer(); 
		
		// Using limited interface
		ICustomer c = vip;
		// Imagine sending to some subsystem, print for now...
		System.out.println(c.getOrderValue());

	}
	
	public interface ICustomer {
		public double getOrderValue();
	}
	
	public interface IVIPCustomer extends ICustomer {
		public double getReduction();
	}
	
	// Probably have abstract class here
	public static class Customer implements IVIPCustomer{

		@Override
		public double getOrderValue() {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public double getReduction() {
			// TODO Auto-generated method stub
			return 0;
		}
		
	}

}
