package factory;

/**
 * Separating out the construction from the use. Centralizing construction to
 * factory
 *
 * This is: Static factory, responsibility of class is to create some object(s)
 *
 * @author hajo
 *
 */
public class Factory {

    private Factory() {
    }

    // Construction a complex object (a factory method)
    public static IMyApp getMyApp(/* possible args */) {
        // All 'new' here 
        A a = new A();
        B b = new B();

        C c = new C(a, b);
        D d = new D(c);

        return d; // return interface to be used by others
    }

    // --------- TYPES --------
    // static just for technical reasons, normally not static
    public static class A {

    }

    public static class B {

    }

    public static class C {

        public C(A a, B b) {
            // TODO
        }

    }

    public interface IMyApp {

    }

    public static class D implements IMyApp {

        public D(C c) {
            // TODO
        }

    }
}
