package exception.translation;

import java.io.PrintWriter;
import java.io.StringWriter;

/**
 * Translate low level exception to anything relevant for
 * the actual abstraction level
 * @author hajo
 *
 */
class MeaningFullException extends RuntimeException {

    private static final long serialVersionUID = 1L;
    private final String stackTrace;
    public Exception originalException;

    public MeaningFullException(Exception e) {
        super(e.toString());
        originalException = e;
        StringWriter sw = new StringWriter();
        e.printStackTrace(new PrintWriter(sw));
        stackTrace = sw.toString();
    }

    public void printStackTrace() {
        printStackTrace(System.err);
    }

    public void printStackTrace(java.io.PrintStream s) {
        synchronized (s) {
            s.print(getClass().getName() + ": ");
            s.print(stackTrace);
        }
    }
    public void rethrow() throws Exception { 
        throw originalException; 
   }
}
