package mvc.basic;

import java.util.ArrayList;
import java.util.List;

/**
 * Model part of application
 * 
 * NOTE: The model should not handle services
 * Separations of concern! 
 * @author hajo
 *
 */
public class Model {

	private final List<IObserver> obs = new ArrayList<>();
	private int i = 0;

	// Will change state
	public void setIt(int i) {
		this.i = i;
		notifyAll(this.i);
	}
	
	public void addObserver(IObserver o){
		obs.add(o);
	}

	// This seems to be a service
	private void notifyAll(int i) {
		StateChange s = new StateChange(i);
		for (IObserver o : obs) {
			o.notify(s);
		}
	}

}
