package mvc.controlview1;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JLabel;
import javax.swing.JTextField;

/**
 * A Control class with reference to GUI components
 * 
 * Have no direct possibilities to manipulate GUI
 * (possible create this as anonymous inner sub class)
 * 
 * AbstractAction has a built in Map, possible to
 * store and retrieve values
 * 
 * This is the only implemented class like this i need
 * a mouse listener have to create something similar
 * 
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class Control extends AbstractAction {
  
	public static final String OUT = "out";
	public static final String IN = "in";

	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		System.out.println("Control called..." + cmd);
		
		// Stored in MainFrame
		JTextField t =  (JTextField) this.getValue(IN);
		String s = t.getText();
		JLabel l = (JLabel) this.getValue(OUT);
		l.setText(s);
	}
}
