package canonical.equal;

/**
 * Class with overridden equals (basic possible problems with inheritance)
 *
 * @author hajo
 */
public class MyClass {

    private final long id;

    public MyClass(long id) {
        this.id = id;
    }

    // Warning: Problems with inheritance
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        MyClass other = (MyClass) obj;
        return id == other.id;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + (int) (id ^ (id >>> 32));
        return result;
    }

}
