package canonical.equal;

import java.util.HashMap;
import java.util.Map;

/**
 * Using equals by value by overriding equals() (Object.equal is by reference)
 *
 * NOTE : This will cause problems with inheritance, see inheritance
 *
 * @author hajo
 *
 */
public class TestEquals {

    public static void main(String[] args) {
        testEquals();
        testBadEquals();

    }

    private static void testEquals() {
        MyClass a = new MyClass(1);
        MyClass b = new MyClass(1);
        MyClass c = new MyClass(2);

        System.out.println(a.equals(b));
        System.out.println(b.equals(c));
        // If equal should have same hashCode
        System.out.println(a.hashCode() + " " + b.hashCode());      
    }

    private static void testBadEquals() {
        MyBadClass a = new MyBadClass(1);
        MyBadClass b = new MyBadClass(1);
        System.out.println(a.equals(b));
        
        Map<MyBadClass, String> m = new HashMap<>();       
        // Use MyBadClass as key
        m.put(a, "AAA");
        // b equals a but not found!
        System.out.println(m.get(b));   
    }

}
