package comparator;

import java.util.Comparator;

/**
 * Comparator for comparing customer first names
 */
public class FirstNameComparator implements Comparator<Customer> {

    @Override
    public int compare(Customer c1, Customer c2) {
        if (c1 == c2) {
            return 0;
        }
        String name1 = c1.getFirstName();
        String name2 = c2.getFirstName();
        return name1.compareTo(name2);
    }

    /*
     Indicates whether some other object is "equal to" this comparator. 
     This method must obey the general contract of Object.equals(Object). 
     Additionally, this method can return true only if the specified
     object is also a comparator and it imposes the same ordering
     as this comparator. Thus, comp1.equals(comp2) implies that 
     sgn(comp1.compare(o1, o2))==sgn(comp2.compare(o1, o2)) for every
     object reference o1 and o2.
     @Override
     public boolean equals(Object obj){
       // ...
     }
     */
}
