package exception._finally;

/**
 * Finally is guaranteed to execute!!
 * @author hajo
 */
public class TestFinally {

    public static void main(String[] args) {
        doIt();
        badFinally();
        System.out.println("Done");
    }

    private static void doIt() {
        try {
            return;  // Just to check finally, in practice sensless
        } catch (Exception e) {
            e.printStackTrace();   // For now
        } finally {
            System.out.println("This is always done");
        }
    }

    private static void badFinally() {
        try {
            silly();   // Generate exception , NO catch!
        } finally { // Warning because of return
            return; // Exception swallowed 
            //System.out.println("Will not swallow");  // This is ok, (remove return)
        }
    }

    private static void silly() {
        throw new RuntimeException();
    }
}
