package mvc.eventbus;

/**
 * A single event
 *
 * @author hajo
 *
 */
public class Event {

    // All possible types of events listed used in
    // GUI to check if we should react
    public enum Tag {

        I_CHANGED,
        /*I_ODD,  Not used
         I_EVEN,
         RESULT_CHANGED*/
    }
    private final Tag tag;
    // The new value (sent to GUI)
    private final Object value;

    public Event(Tag tag, Object value) {
        this.tag = tag;
        this.value = value;
    }

    public Tag getTag() {
        return tag;
    }

    public Object getValue() {
        return value;
    }

    // Useful for tracing
    @Override
    public String toString() {
        return "Event[" + tag + "," + value + "]";
    }

}
