package option;

/**
 * Used when value exists
 *
 * @author hajo
 *
 * Could move getOrElse to abstract base class
 *
 * @param <T>
 */
public final class Some<T> implements Option<T> {

    private final T value;

    public Some(T value) {
        this.value = value;
    }

    @Override
    public boolean hasValue() {
        return true;
    }

    @Override
    public T get() {
        return value;
    }

    @Override
    public T getOrElse(T alternative) {
        return hasValue() ? get() : alternative;
    }
}
