package generic.canonical;

import java.lang.reflect.Method;

/**
 * 
 * @author Angelika Langer
 *
 */
public class GenericClone {

    class Triple<T> implements Cloneable {
        private T fst, snd, trd;

        public Triple(T t1, T t2, T t3) {
            fst = t1;
            snd = t2;
            trd = t3;
        }

        // Covariant return type
        public Triple<T> clone() {
            Triple<T> clon = null;
            try {
                clon = (Triple<T>) super.clone(); // unchecked warning 
            } catch (CloneNotSupportedException e) {
                throw new InternalError();
            }
            try {
                Class<?> clzz = this.fst.getClass();
                Method meth = clzz.getMethod("clone", new Class[0]);
                Object dupl = meth.invoke(this.fst, new Object[0]);
                clon.fst = (T) dupl; // unchecked warning 
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                Class<?> clzz = this.snd.getClass();
                Method meth = clzz.getMethod("clone", new Class[0]);
                Object dupl = meth.invoke(this.snd, new Object[0]);
                clon.snd = (T) dupl; // unchecked warning 
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                Class<?> clzz = this.trd.getClass();
                Method meth = clzz.getMethod("clone", new Class[0]);
                Object dupl = meth.invoke(this.trd, new Object[0]);
                clon.trd = (T) dupl; // unchecked warning 
            } catch (Exception e) {
                e.printStackTrace();
            }
            return clon;
        }
    }

}
