package generic.capture;

import java.util.ArrayList;
import java.util.List;

/**
 * Using a helper method to do wild card capture
 * @author hajo
 *
 */
public class WildcardCaptureWithHelperMethod {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		List<Integer> l = new ArrayList<>();
		foo(l);
		
	}		
		
	// --------- Methods ----------------	
	
	public static void foo(List<?> l) {
		// Bad! Can't set, i.e. add elements to collection of unknown type
		// l.set(0, l.get(0));
		
		// Using helper method
		fooHelper(l);
	
	}
	
	// Helper method created so that the wild card can be captured
	private static <T> void fooHelper(List<T> l) {
		l.set(0, l.get(0));
	}
}
