package generic.methods;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Type inference for generic methods
 */
public class InferenceFromParameters {

	
    public static void main(String[] args) {
      
        Object[] oa = new Object[100];
        Collection<Object> co = new ArrayList<Object>();
        fromArrayToCollection(oa, co); // No explicit T,T inferred to be Object

        String[] sa = new String[100];
        Collection<String> cs = new ArrayList<String>();
        fromArrayToCollection(sa, cs); // T inferred to be String
        fromArrayToCollection(sa, co); // T inferred to be Object

        Integer[] ia = new Integer[100];
        Float[] fa = new Float[100];
        Number[] na = new Number[100];
        Collection<Number> cn = new ArrayList<Number>();
        fromArrayToCollection(ia, cn); // T inferred to be Number
        fromArrayToCollection(fa, cn); // T inferred to be Number
        fromArrayToCollection(na, cn); // T inferred to be Number
        fromArrayToCollection(na, co); // T inferred to be Object  
        
        // Number[] and Collection<String> has no common supertype
        //fromArrayToCollection(na, cs); // compile-time error
    }
    
    // A family of overloaded methods
    public static <T> void fromArrayToCollection(T[] a, Collection<T> c) {
        for (T o : a) {
            c.add(o); // Correct
        }
    }
    

}
