package reflection.plugin;

import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;

/**
 * Finding plugins anywhere
 * @author hajo
 *
 */
public final class PluginFinder {

	private String qualifiedClassName;
	private String url;

	public PluginFinder(String qualifiedClassName, String url) {
		this.qualifiedClassName = qualifiedClassName;
		this.url = url;
	}

	// Bad exception handling	
	public IPlugin find() {
		IPlugin p = null;

		try {
			System.out.println("Try loading " + qualifiedClassName + " from "
					+ url);
			// This is bad, but to complicated to solve for now
			// Doesn't implement AutoCloseable
			ClassLoader loader = new URLClassLoader(new URL[] { new URL(url) },
					IPlugin.class.getClassLoader());

			Class<?> clazz = loader.loadClass(qualifiedClassName);
			System.out.println("URLLoader found " + clazz);
			Class<? extends IPlugin> subClazz = clazz.asSubclass(IPlugin.class);
			p = subClazz.newInstance();
		} catch (ClassNotFoundException | InstantiationException
				| IllegalAccessException | MalformedURLException e) {
			e.printStackTrace();
		}
		return p;
	}
}
