package generic.basic;

/**
 * Basic generic interface and implementations of
 *
 * @author hajo
 *
 */
public class GenericInterface {

    public static void main(String[] args) {
        MyClass m = new MyClass();
        MyInterface<String> s = new MyOtherClass<>();

        System.out.println(m.doIt(1));
        System.out.println(s.doIt("aaa"));
    }

	// ------- Types --------------
    // Generic interface
    public interface MyInterface<T> {

        public T doIt(T t);
    }

    // Non generic implementation
    public static class MyClass implements MyInterface<Integer> {

        @Override
        public Integer doIt(Integer t) {
            return t;
        }

    }

    // Generic implementation
    public static class MyOtherClass<T> implements MyInterface<T> {

        @Override
        public T doIt(T t) {
            return t;
        }

    }

}
