package generic.canonical;

/**
 * 
 * @author Angelika Langer
 *
 */
public class GenericEquals {

    public static class Triple<T> {
        private final T fst, snd, trd;

        public Triple(T t1, T t2, T t3) {
            fst = t1;
            snd = t2;
            trd = t3;
        }

        @Override
        public boolean equals(Object other) {
            if (this == other)
                return true;
            if (other == null)
                return false;
            if (this.getClass() != other.getClass())
                return false;
            Triple<?> otherTriple = (Triple<?>) other;
            return (this.fst.equals(otherTriple.fst)
                    && this.snd.equals(otherTriple.snd) && this.trd
                        .equals(otherTriple.trd));
        }
    }
}
