package generic.inheritance;

/**
 * Collected variations of inheritance and generic
 * 
 * @author hajo
 * 
 */
public class GenericInheritance {

    @SuppressWarnings("unused")
    public static void main(String[] args) {
        B<Number> b = new B<Number>();
        Number n = b.getBData(); // Yes a Number
        String s = b.getString(); // Yes , a String

        B2 b2 = new B2();
        String s2 = b2.getData();

        B3<Number> b3 = new B3<Number>();
        Number n3 = b3.getT(); // Yes a Number
        Number s3 = b3.getData();
        //getbTData(); // ...also a Number
    }

    // static just to make it a top-level (ordinary class)
    public static class B<T> extends A<String> {
        private T bTData;

        public T getBData() {
            return bTData;
        }

        public String getString() {
            return getData();
        }
    }

    // Possible ---------------------------
    public static class B2 extends A<String> {
        @Override
        public String getData() {
            return "abc";
        }
    }

    // --------------------------------------------
    public static class B3<T> extends A<T> {
        private T bTData;

        public T getT() {
            return getData();
        }

        public T getbTData() {
            return bTData;
        }
    }

    // BAD, Extends raw non generic version of A------------------
    /*
       public static class B1<T> extends A { // Not implemented }
     */

    // Possible 
    public static class B4<T, E> extends A<E> {
        // Not implemented }
    }

    // ----------- Types ------------------

    public static class A<T> {

        private T data;

        public A() {
        }

        public void setData(T data) {
            this.data = data;
        }

        public T getData() {
            return data;
        }
    }

}
