package generic.methods;

import java.util.ArrayList;
import java.util.List;

/**
 * Generic methods
 * @author hajo
 *
 */
public class GenericMethods {
    public static void main(String[] args) { 
        List<Box<String>> strBoxes = new ArrayList<>();
        List<Box<Integer>> iBoxes = new ArrayList<>();
        
  
        // Infers <String> fillBoxes
        fillBoxes("abc", strBoxes);
        
        // Infers <Integer> fillBoxes
        fillBoxes3(123, iBoxes);
        
        // If using return value
        List<Box<Integer>> li = fillBoxes3(123, iBoxes);
        li.clear();
        
        
        //fillBoxes(123, strBoxes);  // BAD, can't find common type
    }
    
    // ------------ Methods -------------------------
    

    // Type parameter T before return type!
    public static final <T> void fillBoxes(T u, List<Box<T>> boxes) {
        for (Box<T> box : boxes) {
            box.add(u);   
        }
    }
    
    // Static ok! 
    public static final <T> void fillBoxes2(T u, List<Box<T>> boxes) {
        for (Box<T> box : boxes) {
            box.add(u);   // OK to add!!!!
        }
    }
    // Parameterized type as return value
    public static <T> List<Box<T>> fillBoxes3(T u, List<Box<T>> boxes) {
        for (Box<T> box : boxes) {
            box.add(u);   
        }
        return boxes;
    }
     
    // ---------- Types --------------------
    
    public static class Box<T> {
    	   
        private T t;   
        
        public Box( T t){
        	this.t = t;
        }

        public void add(T t) {
            this.t = t;
        }

        public T get() {
            return t;
        }
    }
    
}
