package generic.methods;

/**
 * Method type inference sometimes counter intuitive
 * 
 * NOTE: Inference also can fail (compile time)
 * 
 * @author hajo
 *
 */
public class InferenceCounterintuitive {

    public static void main(String[] args) {
        
        fill (new String[5], "XYZ"); // T=String, ok
        
        // Common super type is Object & Serializable & Comparable
        // Compiles but ArrayStoreException
        fill (new String[5], new Integer (100)); 
        
        
        fill2(new Number[5], new Integer (100));// T = Number, OK
        
        //Inferred type for String, Serializable, but Number  don't extends Serializable
        //fill2(new Integer[5], new String[5]); // BAD
        
    }
    
    // ---------- Methods ----------------------
    
    public static <T> void fill( T[] array, T elem) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = elem;
        }
    }
       
    public static <T extends Number> void fill2( T[] array, T elem) {
        for (int i = 0; i < array.length; ++i) {
            array[i] = elem;
        }
    }
    
}
