package generic.overrideoverload;

/**
 * Overload generic method doesn't work like we used to
 *
 * Angelika Langer:
 * We pass an argument of type  String to the overloaded 
 * method and yet the version for type  Object is called. The reason is that the 
 * compiler creates only one byte code representation per generic type or 
 * method and maps all instantiations of the generic type or method to that 
 * one representation. generic method translated to; 
 * 
 * void genericMethod( Object t) { 
 *    overloadedMethod (t) ;  
 *}
 * 
 * @author hajo
 *
 */
public class GenericOverloadSubtleties {

    static void overloadedMethod(Object o) {
        System.out.println("overloadedMethod(Object) called");
    }

    static void overloadedMethod(String s) {
        System.out.println("overloadedMethod(String) called");
    }

    static void overloadedMethod(Integer i) {
        System.out.println("overloadedMethod(Integer) called");
    }

    static <T> void genericMethod(T t) {
        System.out.println("generic method called");
        //System.out.println(t.getClass().getSimpleName());  
        overloadedMethod(t); // Which method is called? 
    }

    public static void main(String[] args) {
        overloadedMethod("abc");
        genericMethod("abc");
        GenericOverloadSubtleties.<String> genericMethod("abc");
    }

}
