package generic.typecompatibility;

import java.util.ArrayList;
import java.util.List;

/**
 * Typecompatibility for parametrized types
 * @author hajo
 *
 */
public class ParameterizedTypeCompatibility {

	
	public static void main(String[] args) {
		List raw = new ArrayList();			// Raw type (BAAD)
		List<?> wild = new ArrayList<>();		// Wild card 
		List<? extends Number> ubound = new ArrayList<>();// Wild card with upper bound  
		List<? super Number> lbound = new ArrayList<>();// Wild card with lower bound  
		List<Number> p = new ArrayList<>(); // Parameterized type

		// Raw type super to any parametrized type
		raw = p; // Ok, raw type to all
		raw = wild; // Ok, raw type is super type
		raw = ubound;
		raw = lbound;
				
		wild = raw; // Ok
		wild = p; // Ok, wild card super type for all parametrized type
		wild = ubound;
		wild = lbound;
		
		ubound = raw;
		//ubound = wild; // Compile error
		ubound = p;
		lbound = raw;
		// lbound = wild;  // Compile error
		lbound = p;
		
		p = raw;
		//p = wild; //Compile error
		//p = ubound; //Compile error
		//p = lbound;
		
		//ubound = lbound;  // No, no
		//lbound = ubound;
		
		
		
	}
}
