package generic.typeparameter.bounded;

import java.io.Serializable;

/**
 * Possible usage of type parameter and bound
 *
 * @author hajo
 *
 */
public class BoundedTypeParameterClass {

    public static void main(String[] args) {
		// No, this is not a type parameter it's a parameterized type
        // List<T extends Number> elist;
        // List<T super Number> slist;
    }

    // Generic class declaration
    public static class A1<T extends Number> {

        private T t;   // Need T, a ? would be useful
    }

    /* No can't use super, senseless see Angelika Langer
     public static class A2<T super Number> {
     }*/
    public static class A3<T extends Number & Serializable> {

        private T t;   // Need T, a ? would be useful 
    }

    // Generic method declaration. 
    public <T extends Number> void do1(T t) {
    }

    // Ok, bit more confusing
    public <T extends Comparable<T>> T do2(T t) {
        return null;
    }

    // No
    //public <T super Number> void doOther(T t) {}
}
