package generic.wildcard.capture;

import java.util.HashSet;
import java.util.Set;

/**
 * Wild card capture allows a type variable to be instantiated to a wild card
 *
 * @author hajo
 *
 */
public class WildcardCapture {

    public static void main(String[] args) {
        // Unknown type
        Set<?> set = new HashSet<>();

        // Set<?> :> Set<T> !! Wrong way!!
        doIt(set);

    }

    /*
     *  Doesn't matter if called with Set<?>
     *  We don't know element type for Set<?>, but 
     *  when method called given set will have some
     *  specific element type, any such type will do
     *  (type safe) 
     */
    public static <T> Set<T> doIt(Set<T> set) {
        // T as Object only
        T t = set.iterator().next();
        return set;
    }

}
