package generic.wildcard.restrictions;

import java.util.ArrayList;
import java.util.List;

/**
 * Restrictions on <? super T > collection
 * @author hajo
 *
 */
public class RestrictionsLowerBound {

	public static void main(String[] args) {
		List<? super Integer> list;

		// List could be any of these
		list = new ArrayList<Integer>();// Integer is a "superclass" of Integer (in this context)
		list = new ArrayList<Number>(); // Number is a superclass of Integer
		list = new ArrayList<Object>();

		// Read
		/*
		You aren't guaranteed an Integer because list could be pointing at 
		a List<Number> or List<Object>.
		You aren't guaranteed an Number because list could be 
		pointing at a List<Object>.
		The only guarantee is that you will get an instance of an Object.
		*/
		Object o = list.get(0);
		
		// Write
		/*
		You can add an Integer because an Integer is allowed in any of above lists.
		You can add an instance of a subclass of Integer because an instance of a subclass 
		of Integer is allowed in any of the above lists.
		You can't add a Double because list could be pointing at a ArrayList<Integer>.
		You can't add a Number because list could be pointing at a ArrayList<Integer>.
		You can't add a Object because list could be pointing at a ArrayList<Integer>.
		*/
		list.add(55);
		list.add(null);

	}
	
	

}
