package generic.wildcard.restrictions;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Restrictions on <? super T > collection
 * @author hajo
 *
 */
public class RestrictionsUnbound {

	public static void main(String[] args) {
		List<?> list;

		// List could be any of these
		list = new ArrayList<Integer>();// Integer is a "superclass" of Integer (in this context)
		list = new ArrayList<Number>(); // Number is a superclass of Integer
		list = new ArrayList<Object>();

		// Read
		/*
		The only guarantee is that you will get an instance of an Object or 
		*/
		Object o = list.get(0);
		
		// Write
		/*
		You can't add a Integer because list could be pointing at a ArrayList<String>.
		You can't add a Number because list could be pointing at a ArrayList<Integer>.
		You can't add a Object because list could be pointing at a ArrayList<Integer>.
		*/
		list.add(null);
		
		 // ----------- Nested wild card ---------------------------------
        // Can add!! List a known type
        List<List<?>> lists = new ArrayList<>();
        lists.add(Arrays.asList("one", "two"));
        System.out.println(lists.toString());
        

	}

}
