package generic.wildcard.restrictions;


import java.util.ArrayList;
import java.util.List;
import java.util.Arrays;

/**
 *
 * Restrictions on <? extends T > collection
 * @author hajo
 *
 */
public class RestrictionsUpperBound2 {

    public static void main(String[] args) {

        // Any of these are valid
        List<? extends A> list = new ArrayList<A>();
        List<? extends A> list2 = new ArrayList<B>(); 
        List<? extends A> list3 = new ArrayList<C>();  

        // Read ok
        Object o = list.get(0);
        A a = list.get(0);

        // Can't get these
        /*B b = list.get(0);
        C c = list.get(0);*/

        // Write, No
        /*list.add(new A());
        list.add(new B());
        list.add(new C());*/
        list.add(null);

        // ----------- Nested wild card ---------------------------------
        // Can add!! List is a known type
        List<List<? extends A>> lists = new ArrayList<>();
        lists.add(Arrays.asList(new A()));
        System.out.println(lists.toString());
        List<? extends A> l = lists.get(0);  
    }

    public static class A {

    }

    public static class B extends A {

    }

    public static class C extends B {

    }
}
