package reflection.access;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

/**
 * Can use reflection to access private attributes
 *
 * @author hajo
 *
 */
public class CallMethodUsingReflection {

    public static void main(String[] args) {
        A a = new A();
        Class<?> clazz = a.getClass();

        try {
            // Have to supply type for parameters
            Method m = clazz.getMethod("getI", new Class<?>[]{Double.class});
            // m invoked on a with param value 6.66
            double d = (double) m.invoke(a, new Object[]{6.66});
            System.out.println(d);
        } catch (SecurityException | IllegalArgumentException | 
                NoSuchMethodException | IllegalAccessException | 
                InvocationTargetException e) {
            e.printStackTrace();
        }
    }

    public static class A {

        private int i = 1;

        public Double getI(Double d) {
            return i + d;
        }
    }

}
