package reflection.plugin;

import java.io.File;

/**
 * Plugin design using reflection  
 * 
 * NOTE: Muse adjust URL below AND deleta local *.class files for
 * plugins
 * 
 * @author hajo
 *
 */
public class Main {

	private final String URL = "http://www.cse.chalmers.se/~hajo/";
	private final static String STALINGRAD = "reflection.plugin.pluginhome.Stalingrad";
	private final static String NARVA = "reflection.plugin.pluginhome.Narva";
	
	private BattleFramework frameWork = new BattleFramework();

	// Download and store locally
	public Main(String battle) {
		IPlugin aBattle = null;
		if ("S".equals(battle)) {
			aBattle = new PluginFinder(STALINGRAD, URL).find();
		} else {
			aBattle = new PluginFinder(NARVA, URL).find();
		}
		// Connect plugin and framwork
		aBattle.hook(frameWork);
		frameWork.runIt(aBattle);
	}

	public static void main(String[] args) {
		System.out.println("Start main");
		// Delete local classes
		File f = new File("./reflection/plugin/pluginhome/Narva.class");
		f.delete();
		f = new File("./reflection/plugin/pluginhome/Stalingrad.class");
		f.delete();
	
		new Main("N"); // or "N"
	}
}
