package byreferencebyvalue;

/**
 * Always have to check (or know) if by reference or by value
 * 
 * Not even the JDK (the huge standard Java library) 
 * defines equals() consistently.  Consider the following examples 
 * using the string and the string buffer classes from the JDK:
 * 
 * Don't believe that Java mechanisms, like the equal() function, would help 
 * retain value semantics.
 * 
 * @author Angelica Langer
 * 
 *
 */
public class ByReferenceOrByValue {

	public static void main(String[] args) {
		String s = "Hello World !";
		
		String s1 = new String(s);
		String s2 = new String(s);
		
		// As expected
		System.out.println(s1.equals(s2));

		StringBuffer sb1 = new StringBuffer(s);
		StringBuffer sb2 = new StringBuffer(s);

		// Surprise..!?
		System.out.println(sb1.equals(sb2));
	}

}
