package linkedlist;

/**
 * Traversing a linked data structure using an explicit pos-variable
 * @author hajo
 *
 */
public class TraverseLinkedList {

	public static void main(String[] args) {
		MyList m = new MyList();
		System.out.println(m);
	}

	// The List class entry to the chain of nodes
	public static class MyList {

		private Node head;      // Just need a reference to the first

		public MyList() {	
			head = new Node(1, new Node(2, new Node(3, new Node(4, null))));
		}

		// TRAVERSING!! Often simplifies debugging
		@Override
		public String toString() {
			Node pos = head;           // Init pos 
			StringBuilder b = new StringBuilder();
			while (pos != null) {   // Check end of list
				b.append(pos.data);
				pos = pos.next;     // Move pos
			}
			return b.toString();
		}

	}
	
	// Helper class, the nodes in the list
	public static class Node {
		public int data;
		public Node next;

		public Node(int data, Node next) {
			this.data = data;
		    this.next = next;
		}
	}

}
