package testing;

import static org.junit.Assert.*;


import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 * A unit test for CUT class
 * 
 * To run: Right click > Run as > JUnit test
 * @author hajo
 *
 */
public class TestCUT {

    @BeforeClass // Run once before all test methods
    public static void beforeClass(){
        // No System.out in test, this is just a demo
    	System.out.println("Before class");
    }
    
    @Before // Run before every test method
    public void before(){
        System.out.println("Before");
    }
    
    // There are also: @After, @AfterClass
    
    @Test // A test method, must be public and void
    public void testGetComplicatedResult() { // Use a descriptive name
       CUT c = new CUT();
       
       c.setDatasetUpperBound(5);
       int result = c.getComplicatedResult();
       
       // Defined by JUnit, see static import
      assertTrue(result == 30);  // Use any boolean expression
    }
          
    @Test(expected=IllegalStateException.class)
    public void setUpperBoundToNgativeValue() {
        CUT c = new CUT();
        c.setDatasetUpperBound(-1);
        // No assert will throw
    }
    
}
