package tree;

import java.util.ArrayList;
import java.util.List;

/**
 * Building a tree as a linked data structure
 * @author hajo
 *
 */
public class Tree {

	public static void main(String[] args) {
		MyTree m = new MyTree();

		System.out.println(m.countNodes());
		
	}

	// Tree
	public static class MyTree {

		private final Node root; // Just one start reference to all nodes

		public MyTree() {
			root = new Node(1, new Node(2, new Node(4, null, null), new Node(5,
					null, null)), new Node(3, new Node(6, null, null),
					new Node(7, null, null)));
		}

		// Need a "start" method to get recursion going
		int countNodes() {

			//return countNodesR(root);

			List<Node> nodes = new ArrayList<>();
			countNodesRT(root, nodes);
			return nodes.size();

		}

		// Recursive traversing and counting. Not tail recursive
		private int countNodesR(Node node) {
			if (node == null) {
				return 0;
			} else {
				return 1 + countNodesR(node.left) + countNodesR(node.right);
			}

		}

		// Recursive traversing and counting. Tail recursive.
		// NOTE: Parameter nodes is identical through all recursive calls
		// This is high lighted with final
		private void countNodesRT(Node node, final List<Node> nodes) {
			if (node == null) {
				return;
			} else {
				if (nodes.indexOf(node) < 0) {
					nodes.add(node);
				}
				countNodesRT(node.left, nodes);
				countNodesRT(node.right, nodes);
			}
		}
	}

	// Nodes in tree
	public static class Node {
		public int data;
		public Node left;
		public Node right;

		public Node(int data, Node left, Node right) {
			this.data = data;
			this.left = left;
			this.right = right;
		}
	}

}
