package linkedlist;

/**
 * The list class, a collection of Nodes
 * @author hajo
 */
public class LinkedList {

    private final Node head;      // Just need a reference to the first

    public LinkedList(Node head) {
        this.head = head;
    }

    // Often simplifies debugging
    @Override
    public String toString() {
        StringBuilder b = new StringBuilder();
        
        // Traversing
        Node pos = head;           // Init pos 
        while (pos != null) {   // Check end of list
            b.append(pos.data);
            pos = pos.next;     // Move pos
        }
        return b.toString();
    }
}
