package clone.constructor;

/**
 * No constructor may be used when implementing clone
 * 
 * ClassCastException
 * 
 * @author hajo
 *
 */
public class BadCloneUsingContructor {
  
    public static void main(String[] args) throws CloneNotSupportedException  {
        A a1 = new A();
        B b1 = new B();
        
        
        System.out.println("a1 is cloneable: " + (a1 instanceof Cloneable));
        System.out.println("a1 : " +  a1);
        A a2 = (A) a1.clone(); 
        System.out.println("a2 : " +  a2);
        
        System.out.println("b1 is: " + b1);
        System.out.println("b1 is cloneable: " + (b1 instanceof Cloneable)); 
      
             
        B b2 = (B) b1.clone(); 
        System.out.println("b2 is: " + b2);
        System.out.println("b2 is cloneable: " + (b2 instanceof Cloneable));        
    }
    
    public static class A implements Cloneable{

        @Override
        public Object clone() {                 
            A a =  new A();   // Bad, exception in subclass
            return a;
        }
        
    }
    
    public static class B extends A implements Cloneable {

        @Override
        public Object clone() {
            Object o = super.clone();
            // Dynamic type is (should be) B but is A
            System.out.println("Inside B: super.clone type is "
                    + o.getClass().getSimpleName());

            B b = (B) o;
            return b;
        }
    }
}
