package covariance;

/**
 * This shows how to use covariant return types
 * @author hajo
 *
 */
public class Main {
    public static void main(String[] args) {
        A a1 = new A();
        B b = new B();
        A a2 = b;

        C c1 = a1.get(); // Get C object
        C c2 = a2.get(); // Get D object
        System.out.println("I'm really a " + c2.getClass());
        
        c1.doIt();
        c2.doIt();  //Never dangerous
        
        // Runtime type B
        a2.contraParams(new D());       
        // Can't use base class as param (weaker pre condition)
        // Compile time type check reject this
        // a2.contraParams(new C());  
        
        // This will work
        ((B) a2).contraParams(new C());
        
        // No contra variance, just overloading
        b.contraParams(new C()); 
        b.contraParams(new D());  //Inherited from A
    }
}
