package equals.mixedtype.fixsymmetry;

import java.util.HashMap;
import java.util.Map;

/**
 *  Mixed type "equals" 
 */

public class Main {

    public static void main(String[] args) {
       A a = new A(1);    //afield = 1 for all
       B b1 = new B(1,2); // b1 not equals b2
       B b2 = new B(1,3);
       
       // Reflexivity, yes, 
       System.out.println("Reflexivity a-a " + a.equals(a));  // True
       System.out.println("Reflexivity b1-b1 " + b1.equals(b1));// True
       
       // Symmetry fixed, ok
       System.out.println("Symmetry a-b1 " + a.equals(b1)); // True
       System.out.println("Symmetry b1-a " + b1.equals(a)); // True
       
       // Transitivity, breaks
       System.out.println("Transitivity b1-a " +  b1.equals(a)); // True (omitting bfield)
       System.out.println("Transitivity a-b2 " +  a.equals(b2)); // True (omitting bfield)
       System.out.println("Transitivity b1-b2 " + b1.equals(b2));// False (and should be)
       
       // Lookup ok for A objects
       System.out.println("*** Lookup ***");
       Map<A, String>map = new HashMap<A,String>();
       map.put(b1, "b1");
       // Use base class as key
       System.out.println(map.get(a)); // If same hashCode this works!
       System.out.println(map.get(b1));
       
       
    }
}
