package copyctor;

/**
 * Using a copy constructor instead of clone
 * (but problems with subclasses using this style, see uno)
 * 
 * @author hajo
 * 
 */
public class TestCopyContructor {

    public static void main(String[] args) {
        A a1 = new A();
        A a2 = new A(a1);

        System.out.println("a1 is: " + a1);
        System.out.println("a2 is: " + a2);

        A a3 = new B(); // Runtime class is B
        A a4 = new A(a3); // Runtime of copy is A!!

        System.out.println("a3 is: " + a3 + " runtim type is "
                + a3.getClass().getSimpleName());
        System.out.println("a4 is: " + a4 + " runtim type is "
                + a4.getClass().getSimpleName());
    }

    public static class A {

        private int value = 999;
        private String[] strs = new String[5];

        public A() {
        }

        // Copy ctor, Ok deep copy
        // But will change type for subclasses
        public A(A a) {
            value = a.value;
            strs = new String[5];
            for (int i = 0; i < strs.length; i++) {
                strs[i] = a.strs[i]; // Strings immutable
            }
        }

        @Override
        public String toString() {
            return getClass().getName() + "@" + Integer.toHexString(hashCode())
                    + ":" + value + ":" + strs;
        }
    }

    public static class B extends A {

    }
}
