
package dp.decorator;

/**
 * The second concrete decorator which adds horizontal scrollbar functionality
 * @author hajo
 */
public class HorizontalScrollBarDecorator extends AbstractWindowDecorator {
        public HorizontalScrollBarDecorator(IWindow decoratedWindow) {
            super(decoratedWindow);
        }

        @Override
        public void draw() {
            decoratedWindow.draw();
            drawHorizontalScrollBar();
        }

        private void drawHorizontalScrollBar() {
            // draw the horizontal scrollbar
        }

        @Override
        public String getDescription() {
            return decoratedWindow.getDescription()
                    + ", including horizontal scrollbars";
        }
    } 

