package equals.mixedtype;

public class B extends A {

    protected int bfield;

    public B() {

    }

    public B(int afield, int bfield) {
        super(afield);
        this.bfield = bfield;

    }

    // Try uncomment (Commented out makes Map work)
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = super.hashCode();
        result = prime * result + bfield;
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!super.equals(obj)) { // Check parent
            return false;
        }
        if (!(obj instanceof B)) { // A is not instance of B! Breaks symmetry.
            return false;
        }
        B other = (B) obj;
        return bfield == other.bfield;
    }

}
