package equals.sametype;

public class Employee extends Person {

    private final String empNr;  // Significant field

    @Override
    public int hashCode() {
        final int PRIME = 31;
        int result = super.hashCode();
        result = PRIME * result + ((empNr == null) ? 0 : empNr.hashCode());
        result = PRIME * result + ((pNumb == null) ? 0 : pNumb.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (!super.equals(obj)) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Employee other = (Employee) obj;
        if (empNr == null) {
            if (other.empNr != null) {
                return false;
            }
        } else if (!empNr.equals(other.empNr)) {
            return false;
        }
        if (pNumb == null) {
            if (other.pNumb != null) {
                return false;
            }
        } else if (!pNumb.equals(other.pNumb)) {
            return false;
        }
        return true;
    }

    public Employee(String name, String empNr) {
        super(name);
        this.empNr = empNr;
    }

}
