package equals.sametype;

import java.util.HashMap;
import java.util.Map;

/**
 * Same type only equals 
 */

public class TestEqualsSameType {

    public static void main(String[] args) {
      
       Student s = new Student("11223344-5566", "123");
       Employee e = new Employee("11223344-5566", "456");
       Person p = new Person("11223344-5566");
       
       // Yes, reflexive
       System.out.println(e.equals(e));
       System.out.println(s.equals(s));
       System.out.println(p.equals(p));
       
       // Symmetry, No, None equal (same only equal)
       System.out.println(s.equals(e));
       System.out.println(e.equals(s));
       System.out.println(s.equals(p));
       System.out.println(p.equals(s));
       System.out.println(e.equals(p));
       System.out.println(p.equals(e));  
       
       // Transitivity, no because not symmetry
       
       Map<Person, String>map = new HashMap<Person,String>();
       map.put(s, "s");
       // Can't find as other type (even if hashCode same)
       System.out.println(map.get(p));
       System.out.println(map.get(e));
       
       // Runtime type equals, ok true
       Student  s1 = new Student("11223344-5566", "999");
       Person p2 = new Student("11223344-5566", "999");
       System.out.println("Runtime class " + s1.equals(p2));  
       
    }
}
