package fragilebaseclass;
import java.util.ArrayList;
import java.util.List;

/**
 * "The fragile base class problem"
 * 
 * Modifications to base class breaks subclasses
 * 
 * Implementor of CountingSet must know implementation of
 * Set.
 * -I.e hidden dependencies base class/subclass
 * -Breaking information hiding.
 * -Can't develop classes in parallel.
 *
 */
public class TestFragileBaseClass {
    public static void main(String[] args) {
        
        CountingSet cS = new CountingSet();
        List<Integer> list = new ArrayList<Integer>();
       
        // Add 2 elements to a collection
        list.add(new Integer(2));
        list.add(new Integer(5));
        
        // Add collection to CountingSet
        cS.addAll( list );
        
        // How many elems in CountingSet??
        System.out.println(cS.getCount());
    }            
    
}
