package edu.gu.cid.translator.core;



/**
 * A language
 * @author hajo
 * 
 */
public class Language  {
	
	/* IETF BCP 47 standard "Tags for Identifying Languages"
	 * Must be in this order to be sorted correct
	 */
	public enum Tag {
		xx_XX, // The undefined language (an extension)
		en_US, 
		sv_SV, 
		de_DE // More to be added (not used)
	}
	
	private final Tag tag;

	public Language(Tag tag) {
		this.tag = tag;
	}
	
	public Language(String tag){
		this.tag = Tag.valueOf(tag);
	}

	public Tag getTag() {
		return tag;
	}
	
	public String getCountryCode(){
		return tag.toString().split("[_]")[0];
	}
	
	public String getRegionCode(){
		return tag.toString().split("[_]")[1];
	}
	
	@Override
	public String toString() {
		return tag.toString();
	}
}
