package edu.gu.cid.translator.gui;

import edu.gu.cid.translator.core.ITranslator;
import edu.gu.cid.translator.ctrl.ExitCtrl;
import edu.gu.cid.translator.ctrl.IOCtrl;
import edu.gu.cid.translator.ctrl.LanguageCtrl;
import edu.gu.cid.translator.ctrl.StartCtrl;
import edu.gu.cid.translator.event.EventBus;




/**
 * Class responsible for build and connect complete GUI
 * 
 * @author hajo
 * 
 */
public final class GUIFactory {

	public static MainFrame getGUI(ITranslator translator) {

		DisplayPanel display = new DisplayPanel();
		// Will have displayPanel as output
		IOCtrl ioCtrl = new IOCtrl(display, translator);
		KeyboardPanel keyboard = new KeyboardPanel(ioCtrl);
		ButtonPanel buttons = new ButtonPanel(ioCtrl);

		InputPanel input = new InputPanel(keyboard, buttons);

		LanguageSelectionPanel languageSelection = 
				new LanguageSelectionPanel(new LanguageCtrl(translator));

		ExitCtrl exitCtrl =  new ExitCtrl();
		MainFrame mf = new MainFrame(input, display, languageSelection,
				new StartCtrl(translator), exitCtrl);

		// A good place to register observers...
		
		return mf;
	}

}
