package edu.gu.hajo.mbclient.core;

import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.rmi.NoSuchObjectException;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.SwingUtilities;

import edu.gu.hajo.mbclient.core.state.IState;
import edu.gu.hajo.mbclient.event.Event;
import edu.gu.hajo.mbclient.event.EventBus;
import edu.gu.hajo.mbclient.io.FileHandler;
import edu.gu.hajo.mbcommon.Constants;
import edu.gu.hajo.mbcommon.IClient;
import edu.gu.hajo.mbcommon.IMessage;
import edu.gu.hajo.mbcommon.IPeer;
import edu.gu.hajo.mbcommon.MBFile;
import edu.gu.hajo.mbcommon.Message;
import edu.gu.hajo.mbcommon.User;

/**
 * Implementation of the many interfaces. The "real" client Serializable
 * important! 
 * 
 * @author hajo
 */
class Client implements ILocalClient, Serializable {

    private static final long serialVersionUID = Constants.SERIAL_V_ID;

    // Here EventBus is used for incoming from server (to GUI)
    private transient final EventBus bus;

    // Server doesn't use these so make'em transient
    private transient List<String> connectedUsers = new ArrayList<String>();
    // Need observers to signal connection state
    private transient final IState context;

    // Used on server side
    private User user;

    public Client(EventBus bus, IState context) {
        this.bus = bus;
        this.context = context;
        System.out.println(context);
    }

    // ILocalClient ------------------------------------------

    // Connection changes handled by context
    public void connect() {
       
    }

    // A lot TODO
}
