package edu.gu.hajo.mbclient;

import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import org.junit.Assert;
import org.junit.Test;

import edu.gu.hajo.mbcommon.Constants;
import edu.gu.hajo.mbcommon.IServer;

/**
 * NOTE : This test has a Run Configuration
 * (Mark file > Run As ... > Run Configuration > 
 *  x = Argsuments > VM Arguments) 
 * 
 * The following parameters must be passed as VM Arguments
 * -Djava.security.policy=security.policy	
 * 
 * @author hajo
 *
 */
public class TestRMI {

	
	@Test
	public void testPingServer() throws RemoteException, NotBoundException {
	    
	    if (System.getSecurityManager() == null) {
            System.setSecurityManager(new SecurityManager());
        }
        
	    // If problems check port 6666 (same as in server project?)
        Registry registry = LocateRegistry.getRegistry("127.0.0.1", 6666);
        IServer s = (IServer) registry.lookup(Constants.MB_SERVER_NAME);
	    
	    
		String msg = s.ping();
		System.out.println(msg); // Bad to print, just for now
		Assert.assertTrue( msg != null);
	}	
}
