package swing.blocking;

import java.awt.BorderLayout;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JButton;
import javax.swing.JFrame;

/**
 * Show effects of blocking calls, see swing.worker
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class CallSlowMethod extends JFrame {
    JButton b1 = new JButton();
    JButton b2 = new JButton();
    
    public CallSlowMethod(){
        b1.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e) {
            	slowMethod();
            }
        });
        b2.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e) {
                System.out.println("Try me...");
            }
        });
        this.setSize(400, 400);
        b1.setText("Very slow call");
        b2.setText("Try me");
        this.setTitle("MainFrame");
        this.setLayout(new BorderLayout());
        this.getContentPane().add(b1, BorderLayout.NORTH);
        this.getContentPane().add(b2, BorderLayout.SOUTH);
        this.setVisible(true);
    }
    
    private void slowMethod(){
        try {
            System.out.println("Started slow method");
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        System.out.println("End slow method");
    }
    
    public static void main(String[] args) {
       new CallSlowMethod();
    }
}
