package swing.mvc;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;

/**
 * Using pluggable look and feel
 * @author Thomas K&#252;nneth
 *
 */
@SuppressWarnings("serial")
public class PluggableLooknFeel extends JFrame {

    JLabel msgLabel;

    public PluggableLooknFeel() {
        super("SuperSimple");
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });

        ActionListener al = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String laf = "javax.swing.plaf.nimbus.NimbusLookAndFeel";
                try {
                    UIManager.setLookAndFeel(laf);
                    SwingUtilities.updateComponentTreeUI(PluggableLooknFeel.this);
                } catch (Exception excep) {
                }
                msgLabel.setText(((JButton) e.getSource()).getText());
            }
        };
        JButton button;
        JPanel buttonPanel = new JPanel();
        buttonPanel.setBorder(new TitledBorder("Click to change look"));
        for (int i = 0; i < 3; i++) {
            button = new JButton("Button #" + (i + 1));
            button.addActionListener(al);
            buttonPanel.add(button);
        }

        JPanel cp = new JPanel(new BorderLayout());
        cp.setBorder(new EmptyBorder(10, 10, 10, 10));
        msgLabel = new JLabel("no button clicked!");
        cp.add(msgLabel, BorderLayout.NORTH);
        cp.add(buttonPanel, BorderLayout.CENTER);

        setContentPane(cp);
        pack();
        setVisible(true);
    }

    public static void main(String[] args) {
        UIManager.LookAndFeelInfo laf[] = UIManager.getInstalledLookAndFeels();
        for (int i = 0, n = laf.length; i < n; i++) {
            System.out.print("LAF Name: " + laf[i].getName() + "\t");
            System.out.println("  LAF Class name: " + laf[i].getClassName());
        }

        new PluggableLooknFeel();
    }
}
