package swing.switchthread;

import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

/**
 * Switching threads from Timer to EDT
 * @author hajo
 *
 */
public class SwitchThread {

    public static class MyTask extends TimerTask {

        private final MainFrame mf;
        int i = 0;
        public MyTask( MainFrame mf){
            this.mf = mf;
        }
        
        
        // This will run every 3rd sec.
        @Override
        public void run() {
            System.out.println(Thread.currentThread());
            
            // Will handle over to EDT
            SwingUtilities.invokeLater(new Runnable() {

                @Override
                public void run() {
                    mf.setLabel(String.valueOf(i));
                }
            });
            
           
            i++;
        }
    };

  
    public static void main(String[] args) {
        MainFrame mf = new MainFrame();
        mf.setVisible(true);
        // Create a timer. NOTE java.util.Timer
        MyTask task = new MyTask(mf);
        // Schedule task for 2 sec delay and 3 sec period
        Timer t = new Timer();
        t.schedule(task, 2000, 3000);
      
    }

    @SuppressWarnings("serial")
    public static class MainFrame extends JFrame {
        private final JLabel l = new JLabel("empty");

        {
            this.getContentPane().add(l);
            this.setSize(200, 200);
        }

        public void setLabel(String s) {
            System.out.println(Thread.currentThread());
            l.setText(s);
        }

    }
}
