package swing.edt;

import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

/**
 * Demonstrate the AWT-Event dispatch thread EDT
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class EventsAndPainting extends JFrame {

    private JButton b = new JButton("Check thread");
    // Which thread run's here?
    private JPanel f = new JPanel() {
        // Should prefer this to older paint() method
        @Override
        public void paintComponent(Graphics g) {
            super.paintComponents(g);
            // Resize frame to see ....
           
            g.drawLine(1, 1, 20, 20);
            System.out.println("Paint component: "
                    + Thread.currentThread().getName());
        }
    };

    // Which thread run's here?
    private Action a = new AbstractAction() {
        @Override
        public void actionPerformed(ActionEvent e) {
            System.out.println("actionPerformed: "
                    + Thread.currentThread().getName());
        }

    };


    public static void main(String[] args) {

        // Here we have the main-thread, 
        System.out.println(Thread.currentThread());

        SwingUtilities.invokeLater(new Runnable() {
            // Which thread runs here?
            public void run() {
                System.out.println(Thread.currentThread());
                new EventsAndPainting().setVisible(true);
            }
        });

        // Main -thread continues and dies here...
    }
    
    public EventsAndPainting() {
        this.setSize(100, 100);
        b.addActionListener(a);
        this.getContentPane().add(b, BorderLayout.NORTH);
        this.getContentPane().add(f, BorderLayout.SOUTH);
    }

}
