    package threads.deadlock;

/**
 *  Run multiple times to see outcome
 */
public class Deadlock {
	
    static class Friend {
        private final String name;
        public Friend(String name) {
            this.name = name;
        }
        public String getName() {
            return this.name;
        }
        
        // NOTE: We have 2 objects 
        public synchronized void bow(Friend friend) {
        	System.out.println( "BOW: Locked object is " + this.name + ", friend is " + friend.getName() );
    
            // 3. If alphonse, try to bow to gaston but object locked!
            // 4. If gaston, try to bow to alphonse but objekt locked!
            System.out.println(friend.getName() + " tries to bow back");
        	friend.bowBack(this);
        }
        
        // Remove synchronized will make it work
        public synchronized void bowBack(Friend friend) {
        	System.out.println( "BOWBACK: Locked object is " + this.name + ", friend is " + friend.getName() );
        }
    }

    public static void main(String[] args) {
        final Friend alphonse = new Friend("Alphonse");
        final Friend gaston = new Friend("Gaston");
        Thread t1 = new Thread(new Runnable() {
            public void run() { alphonse.bow(gaston); }
        });
        Thread t2 = new Thread(new Runnable() {
            public void run() { gaston.bow(alphonse); }
        });
        t1.start();// 1. This thread starts and locks alphonse, then  ...
        t2.start();// 2. ... this thread locks gaston.
    }
}

