package rmi;

import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

import rmi.types.IMyRemoteInterface;
import rmi.types.MyLocalClass;

/**
 * Starting client application
 * @author hajo
 *
 */
public class ClientMain {

    public static void main(String args[]) {

        if (System.getSecurityManager() == null) {
            System.setSecurityManager(new SecurityManager());
        }

        Registry registry;
        try {
            registry = LocateRegistry.getRegistry("127.0.0.1",
                    ServerMain.REGISTRY_PORT);
            IServer serverStub = (IServer) registry
                    .lookup(ServerMain.SERVER_NAME);
            System.out.println("Got stub from registry " + serverStub);
            
            System.out.println(serverStub.ping());
            
            MyLocalClass lc = serverStub.getByValue();
            lc.setI(99);
            System.out.println(lc.toString());
            serverStub.dumpData();
            
            
            IMyRemoteInterface rc = serverStub.getByReference();
            rc.setI(33);
            System.out.println("MyRemoteClass " + rc.getI());
            serverStub.dumpData();
            
            
            
        } catch (RemoteException | NotBoundException e) {
            e.printStackTrace();
        }
    }

}
