package rmi;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import rmi.types.IMyRemoteInterface;
import rmi.types.MyLocalClass;
import rmi.types.MyRemoteClass;

public class Server implements IServer {

    private IMyRemoteInterface remote = new MyRemoteClass();
    private MyLocalClass local = new MyLocalClass();

    public Server() throws RemoteException {
        UnicastRemoteObject.exportObject(remote, ServerMain.SERVER_PORT);
        // Must Unexport when finished !
        // UnicastRemoteObject.unexportObject(remote, true);
    }

    @Override
    public String ping() {
        return "ping";
    }

    @Override
    public MyLocalClass getByValue() {
        return local;
    }

    @Override
    public IMyRemoteInterface getByReference() {
        return remote;
    }

    @Override
    public void dumpData() {
        System.out.println(local.toString() + remote.toString());
    }
}
