package arrays;

/**
 * Array index out of bounds exception
 * Java has a runtime check. 
 * 
 * 
 * All array accesses are checked at run-time; an attempt to 
 * use an index that is less than zero or greater
 * than or equal to the length of the array causes an 
 * ArrayIndexOutOfBoundsException to be thrown. // JLS 10.4
 * 
 * @author hajo
 *
 */
public class ArrayBoundsChecking {
 
    public static void main(String[] args) {
        int i = 5;
    	String[] strs = new String[]{ "a", "b", "c" };
       
        // Better to get an exception at once, instead of...
        String s = strs[i]; // Can't check compile time
        
        // ..much later
        System.out.println(s.charAt(0));
    }     
}
