package minscope;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Example of not minimze scope
 * @author hajo
 *
 */
public class MinScopes {

	List<String> l = new ArrayList<String>();
	List<String> l2 = new ArrayList<String>();

	// Minimize scope of local variable
	public void doIt() {
		Iterator<String> i = l.iterator();
		while (i.hasNext()) {
			System.out.println(i.next());
		}

		Iterator<String> i2 = l2.iterator();
		while (i.hasNext()) {
			System.out.println(i2.next());
		}
	}

	public void doItMinimize1() {
		{
			Iterator<String> i = l.iterator();
			while (i.hasNext()) {
				System.out.println(i.next());
			}
		}

		Iterator<String> i2 = l2.iterator();
		while (i2.hasNext()) {
			System.out.println(i2.next());
		}
	}

	public void doItMinimize2() {
		for (Iterator<String> i = l.iterator(); i.hasNext();) {
			System.out.println(i.next());
		}
		for (Iterator<String> i2 = l2.iterator(); i2.hasNext();) {
			System.out.println(i2.next());
		}
	}
}
