package singleton;

/**
 * Using a Factory to control number of instances (here one)
 * 
 * This is better used together with packages and non-inner classes
 * 
 * @author hajo
 *
 */
public class SingletonFactory {
	// Could also have a pool of if needed
	private static final MyClass instance = new MyClass();

	public static MyClass getMyClass(){
		return instance;
	}
	
	// Exactly one instance of this
	public static class MyClass{
		// Just a dummy class
		public void doIt(){}
	}
	
}
