package nulls.option;

/**
 * Used when null pop's up
 * @author hajo
 * 
 * Could move getOrElse to abstract base class
 *
 * @param <T>
 */
public class None<T> implements Option<T>{

	@Override
	public boolean hasValue() {
		return false;
	}

	@Override
	public T get() {
		// If T a container return empty container (using iterator)
		throw new UnsupportedOperationException("None doesn't have any value");
	}

	@Override
	public T getOrElse(T alternative) {
		return hasValue() ? get() : alternative;
	}
	
	// Should have toString, equals and hasCode here

}
