package subtyping;

/**
 * Sub typing defined as sub class in Java
 * I.e class extends or implements super type (class)
 * 
 * A subclass is always compatible with the super class
 * 
 * @author hajo
 *
 */
public class Subtyping {

	public static void main(String[] args) {
		IA ia = new A();
		
		ia = new B();
		ia = new C();
		//ia = new D();  //Not subtype
		ia = new E();
		
		//A a = new B(); //Not subtype
		A a = new C();
		//a = new D();
		//a = new E();
		
		//B b = new A();
		//B b = new C();
		
		//C c = new D();
		//C c = new E();
		
		D d = new E();
		
	}

	// -------------    TYPES ----------------------
	// Really helps to draw the UML for this
	public interface IA {
		public void doIt();
	}
	
	public static class A implements IA {
		@Override
		public void doIt() {
			// ..-
		}
	}
	
	public static class B implements IA {
		@Override
		public void doIt() {
			// ..-
		}
	}
	
	public static class C extends A {
	}
	
	
	public static class D {
		
	}
	
	public static class E extends D implements IA{
		@Override
		public void doIt() {
			// TODO Auto-generated method stub
		}
	}
	
	
}
