package typeconversions;

/**
 * Casting will bypass the type system (compile time). Should be 
 * used very sparse. AVOID!!!
 * 
 * @author hajo
 *
 */
public class Casting {

	// A widening reference conversion exists from any reference type S to 
	// any reference type T, provided S is a subtype (§4.10) of T.
	public void castingSuccess() {
		// Number :> Integer
		Number n = new Integer(1);
		
		// Unsafe, but possible to bypass with a cast
		Integer m = (Integer) n;
		
		// Lucky this time...
		System.out.println(m);
	}
	
	public void castingDisaster() {
		Integer i = new Integer(1);
		
		Object o = i;  // Ok super type
		String s = (String) o;  // By pass type checker
				
		System.out.println(s);
	}
	
	public void castingUsingRTTI() {
		Integer i = new Integer(1);
		
		Object o = i;  // Ok super type
		if( o instanceof String){
			String s = (String) o;  // Safe
			System.out.println(s);
		}else{
			int j = (int) o; // Cast and box
			System.out.println(j);
		}
	}
	
	
	
}
