package casting;

/**
 * Casting will bypass the type system (compile time). Should be used very
 * sparse. AVOID!!!
 *
 * @author hajo
 *
 */
public class TestCasting {

    // Is there a casting convention???
    public static void main(String[] args) {
        Object o = null; // No objects needed
        A a = null;
        B b = null;
        C c = null;
        IB ib = null;

        // ---------- Classes to class --------
        // Yes, A :> B 
        b = (B) a;

        // NO! no super/subtype relation
        //b = c;
        //c = b;
        // ---- Class to Interface --------
        // Yes, always allowed
        ib = (IB) a;  // Doesnt' implement IB but possible some subclass do
        ib = (IB) b;  // Does implement
        ib = (IB) c;  // Subclass possible implements

        // ---- Class to Array --------
        String[] s = (String[]) o;  // Only allowed
        // s = (String[]) a;        // No!  

        // ---- Interface to class --------
        // Yes, Always legal
        a = (A) ib;  // Even if a doesn't impelemnt a subclass might
        b = (B) ib;
        c = (C) ib;

        // Just to remove warnings
        System.out.println("" + a + b + c + ib);
    }

    // Some types, possible to write inside enclosing class, more later ----
    public class A {

    }

    public class B extends A implements IB {

    }

    public class C extends A {

    }

    public interface IB {

    }

}
