package conversions;

/**
 * This show overloading (of + ) and promotion interacting
 *
 * + is the only overloaded operator in Java (can't create own overloaded
 * operators only methods)
 *
 * @author hajo
 *
 */
public class StringConversionAndPromotions {

    public static void main(String[] args) {
        testConversionOverloading();
    }

    public static void testConversionOverloading() {
        System.out.println(1 + 1);  // + as integer arithmetic 
        System.out.println("1" + "1");// + as string concatenation
        System.out.println(1.0 + 1.0);  // + as floating point arithmetic 

        System.out.println(1 + "1");  // String conversion, then concatenation
        System.out.println(1.0 + "1");  // String conversion, then concatenation
        System.out.println('1' + 1); // Char to integer, then integer arithmetic
        System.out.println(1 + new Integer(1)); //Unboxing, then integer arithmetic
        System.out.println(new Integer(1) + new Double(1.0));  // Unboxing, then to double, floating point arithmetic performed
        System.out.println(1 + 2 + " mammals"); // Integer arithmetic, string conversion, then concatenation
        System.out.println("mammals " + 1 + 2); // String conversion, then concatenation
    }
}
