package introducetypes;

import java.io.Serializable;

/**
 * 
 * A variable of array type holds a reference to an object. Declaring a variable of 
 * array type does not create an array object or allocate any space for array components. 
 * It creates only the variable itself, which can contain a reference to an array.
 * 
 */
public class ArrayIntroduceType {

   
    public static void main(String[] args) {
    	String s = "abc";
    	s.length();  // A method!
    	
    	// New type String[], no array yet (no memory)
    	// All components must have same type
    	String[] s1 = null;
    	//s1.length; // public attribute!! Compile error??? Strange behavior
    	
    	int i = s1.length; 
    	System.out.println(s1.length); 
    	
    	s1 = new String[5];  // No values yet (have 5 nulls)
    	
    	// New type, declaration and initialization
    	String[] s2 = { "aaa", "bbb", "ccc" };
    	
    	// Possible with interface in array, VERY USEFUL!
    	// Possible very different objects but they all are serializable
    	Serializable[] ss = new Serializable[3];
    	
    	
    	// All arrays have the public **length** attribute, which contains the number 
    	// of components of the array. length may be positive or zero
    	System.out.println(s2.length);
    	  	
    }
    
    /*
    // Can't extend arrays, there's no java.lang.Array class
    public static class MyArray extends MyClass[]{
    	
    }
     
    
    public static class MyClass{
    	
    }*/

}
