package introducetypes;

import java.util.List;

/**
 * An interface introduces a new type
 *
 * Me uses convention putting a leading 'I' (upper case i) in interface names.
 * Not all like.
 *
 *
 * @author hajo
 *
 */
public class InterfaceIntroduceType {

    // A type ( a contract) but no implementation
    // The interface should be in it's own file (this i just demo)
    public interface IMyInterface {

        public void doIt();
    }

    public static void main(String[] args) {
        // Have type can declare variable
        IMyInterface mi;
        IMyInterface[] ami;  // Useful, array of "something" fulfilling a contract    

    	// Can't do it like this, no implementation
        //mi = new MyInterface();
    	// Very special way to instantiate from interface
        // Will create anonymous subclass of IMyInterface
        mi = new IMyInterface() {

            /* Can't have constructor, class has no name
             public IMyInterface(){  
             }*/
            @Override
            // Must have an implementation
            public void doIt() {
                // ..'$1'... will be some kind of name (see class files)
                System.out.println("I belong to class with no name!!! " + this);
            }
        };

        mi.doIt();
    }

    public static class A implements IMyInterface {

        @Override
        public void doIt() {
            System.out.println("A");
        }

    }
}
