package override;

/**
 * Polymorphic behavior, override
 *
 * @author hajo
 *
 */
public class SomeOverriding {

    public void test() {
        A a = new A();
        // Methods for a in A (or possible in superclass, not overridden in class)
        // or in any subclass
        a.doIt();  // Chose method from runtime type

        a = new B();
        a.doIt(); // Chose method from runtime type

        B b = new C();
        b.doIt(); // Chose method from runtime type

    }

    // ----------- Types -------------
    public class A {

        public void doIt() {
            System.out.println("Do it A");
        }
    }

    public class B extends A {

        @Override
        public void doIt() {
            System.out.println("Do it B");
        }

    }

    public class C extends B {

        @Override
        public void doIt() {
            System.out.println("Do it C");
        }

        /* Error, no override
         @Override
         public int doIt() {
         return 0;
         }*/
        /* Error, same signature in same scope
         public void doIt() {
         }*/
    }
}
